﻿init python:
    import time
    class zero_timer(renpy.Displayable):
        def __init__(self, amount = 1, repeats = 0,
        tick_function = None, end_function = None
        ):
            super(renpy.Displayable,self).__init__()
            self.amount = amount
            self.repeats = repeats or 1
            self.finite = bool(repeats)
            self.count = 0
            self.current_count = 0
            self.current = None
            self.tick_function = tick_function
            self.end_function = end_function
        def render(self,width,height,st,at):
            if self.repeats > 0:
                if self.current is None:
                    self.current = time.time()
                if (time.time() - self.current) > self.amount:
                    self.current = time.time()
                    self.count += 1
                    if self.tick_function:
                        self.tick_function()
                    if self.finite:
                        self.repeats -= 1
                        if self.end_function:
                            if self.repeats < 1:
                                self.end_function()

            if self.finite:
                img = Text(str(self.repeats))
            else:
                img = Text(str(self.count))
            t = Transform(img)
            child_render = renpy.render(t, width, height, st, at)
            cw, ch = child_render.get_size()

            rv = renpy.Render(cw, ch)
            rv.blit(child_render,(0, 0))
            
            renpy.redraw(self, 0)
            return rv

    class some_minigame:
        def __init__(self):
            self.timer = zero_timer()
            self.count = 0
        def ticker(self):
            self.count += 1
        def announce(self):
            renpy.notify(2)
    def test_function(m):
        renpy.notify(m)

screen timer_test():
    modal True
    default g = some_minigame()
    timer 1 repeat True action Function(g.ticker)
    text str(g.count) pos renpy.random.randint(0,1920),renpy.random.randint(0,1080)
    drag:
        frame:
            xysize 100,100
    button:
        text "next"
        action Return()
screen zero_timer_test():
    modal True
    for i in range(100):
        add zero_timer(renpy.random.random()+.5) pos renpy.random.randint(0,1920),renpy.random.randint(0,1080)

    drag:
        frame:
            xysize 100,100

label zero_timer_example:
    $ test_class = some_minigame()
    show image zero_timer(3, 5, test_function(3), test_class.announce)
    pause
    call screen timer_test
    call screen zero_timer_test
